from decimal import Decimal
import copy

drivers = [{'id': 1, 'time_slots': [[32400, 64800]], 'capacity': 3, 'speed': 30},            
           {'id': 2, 'time_slots': [[32400, 64800]], 'capacity': 3, 'speed': 30}, 
           {'id': 3, 'time_slots': [[32400, 64800]], 'capacity': 3, 'speed': 30}, 
           {'id': 4, 'time_slots': [[32400, 64800]], 'capacity': 3, 'speed': 30}, 
           {'id': 5, 'time_slots': [[32400, 64800]], 'capacity': 3, 'speed': 30},
           {'id': 6, 'time_slots': [[32400, 64800]], 'capacity': 15, 'speed': 30},
           {'id': 7, 'time_slots': [[32400, 64800]], 'capacity': 15, 'speed': 30}]

locations = {'Fishermall, Diliman, Quezon City': {
    (32400, 36000): [{'address': 'Fishermall, Diliman, Quezon City', 'coordinates': [14.6336204, 121.0193792], 'delivery_window': [32400, 36000], 'capacity': 0, 'order_time': 0}, 
                     {'address': 'Pacific Rim Cor. Commerce Ave., Filinvest City, Alabang, Muntinlupa City, 1781 Metro Manila, Philippines', 'coordinates': [14.4200106, 121.033259], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005264'}, 
                     {'address': '4 Kamias Rd, Diliman, Quezon City, Metro Manila', 'coordinates': [14.6310151, 121.0467182], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005265'}, 
                     {'address': '30 Humility St Multinational Village, Paranaque', 'coordinates': [14.4804117, 121.0048727], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005268'}, 
                     {'address': 'Blk 6 lot 13 kalayaan village, brgy. 201, Pasay', 'coordinates': [14.507602, 121.029081], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005274'}, 
                     {'address': 'Barangay 34, Maypajo, Caloocan, Metro Manila, Philippines', 'coordinates': [14.6367721, 120.9729332], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005183'}, 
                     {'address': '2611 Taft Ave, Barangay 68, Pasay City', 'coordinates': [14.5783882, 120.986897], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005184'}, 
                     {'address': '1838 Yakal St, Manila, 237', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 4, 'order_time': 0, 'ref': '1000005186'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 4, 'order_time': 0, 'ref': '1000005188'},
                     {'address': '18 Molave St., Marietta-Romeo Village, Brgy Sta Lucia, Pasig', 'coordinates': [14.5815801, 121.1017699], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005189'}, 
                     {'address': '86E Cotabato St.\nBago Bantay\nAlicia, Quezon City', 'coordinates': [14.6619823, 121.0235792], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005190'}, 
                     {'address': 'BLK 10 Lot 7 Cor Chesa St Model Community, Bgy 120, Zone 009 Tondo, Manila, Philippines', 'coordinates': [14.6205654, 120.9659653], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005192'}, 
                     {'address': 'Le Gran Condominium Eisenhower St. Greenhills, San Juan', 'coordinates': [14.607297, 121.048476], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005205'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 3, 'order_time': 0, 'ref': '1000005211'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 4, 'order_time': 0, 'ref': '1000005224'}, 
                     {'address': '1320 CP Garcia St Moriones, Bgy 123, Zone 009 Tondo, Manila', 'coordinates': [14.6096907, 120.9618301], 'delivery_window': [39600, 46800], 'capacity':2, 'order_time': 0, 'ref': '1000005225'}, 
                     {'address': 'Fairways Towers 5th Avenue corner McKinley Road, Taguig\nUnit N 15A/15/Fairways Towers', 'coordinates': [14.545619, 121.0454128], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005229'}, 
                     {'address': '1310 C. P. Garcia Street, Tondo, Manila, Metro Manila, Philippines', 'coordinates': [14.6105919, 120.9617521], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005233'}, 
                     {'address': '1320 CP Garcia St Moriones, Bgy 123, Zone 009 Tondo, Manila', 'coordinates': [14.6096907, 120.9618301], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005236'}, 
                     {'address': '2176 Jesus St pandacan manila', 'coordinates': [14.5926865, 121.0044297], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005243'}, 
                     {'address': '156 Session Road Quezon City Batasan Hills', 'coordinates': [14.6797936, 121.1032391], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005250'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 5, 'order_time': 0, 'ref': '1000005254'}], 
    (39600, 43200): [{'address': 'Fishermall, Diliman, Quezon City', 'coordinates': [14.6336204, 121.0193792],'delivery_window': [39600, 43200], 'capacity': 0, 'order_time': 0}, 
                     {'address': 'Anaheim 2, California Garden Square, D.M. Guevara St., Highway Hills, Mandaluyong', 'coordinates': [14.5786156, 121.047485], 'delivery_window': [46800, 57600], 'capacity': 2, 'order_time': 0, 'ref': '1000005266'}, 
                     {'address': 'Lebanon Street Don Bosco, Paranaque', 'coordinates': [14.4786895, 121.0327488], 'delivery_window': [46800, 57600], 'capacity': 1, 'order_time': 0, 'ref': '1000005228'}], 
    (57600, 61200): [{'address': 'Fishermall, Diliman, Quezon City', 'coordinates': [14.6336204, 121.0193792], 'delivery_window': [57600, 61200], 'capacity': 0, 'order_time': 0}, 
                     {'address': '940, Maligaya Street, Manila', 'coordinates': [14.5665457, 120.9952634], 'delivery_window': [64800, 72000], 'capacity': 1, 'order_time': 0, 'ref': '1000005242'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [64800, 72000], 'capacity': 5, 'order_time': 0, 'ref': '1000005255'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [75600, 82800], 'capacity': 5, 'order_time': 0, 'ref': '1000005257'}], 
    (50400, 54000): [{'address': 'Fishermall, Diliman, Quezon City', 'coordinates': [14.6336204, 121.0193792], 'delivery_window': [50400, 54000], 'capacity': 0, 'order_time': 0}, 
                     {'address': '81F Madasalin St Teachers Village East Diliman, Quezon City', 'coordinates': [14.6410582, 121.0591618], 'delivery_window': [57600, 64800], 'capacity': 2, 'order_time': 0, 'ref': '1000025061'}]}}

# drivers = [{'id': 10714, 'time_slots': [[36000, 46920], [81000, 91000]], 'capacity': 100, 'speed': 30},
#             {'id': 10715, 'time_slots': [[28800, 32280]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10716, 'time_slots': [[36060, 46920]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10717, 'time_slots': [[34200, 66600]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10718, 'time_slots': [[34200, 66600]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10720, 'time_slots': [[32400, 64800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10721, 'time_slots': [[32400, 64800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10722, 'time_slots': [[32400, 64800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10723, 'time_slots': [[32400, 64800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10724, 'time_slots': [[32400, 64800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10725, 'time_slots': [[32400, 64800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10726, 'time_slots': [[50400, 82800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10727, 'time_slots': [[50400, 82800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10728, 'time_slots': [[50400, 82800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10729, 'time_slots': [[50400, 82800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10730, 'time_slots': [[50400, 82800]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10731, 'time_slots': [[43200, 79200]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10732, 'time_slots': [[43200, 79200]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10733, 'time_slots': [[43200, 79200]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10734, 'time_slots': [[43200, 79200]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10735, 'time_slots': [[43200, 79200]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10736, 'time_slots': [[43200, 79200]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10737, 'time_slots': [[45000, 81000]], 'capacity': 100, 'speed': 30},
#             {'id': 10738, 'time_slots': [[45000, 81000]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10739, 'time_slots': [[45000, 81000]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10740, 'time_slots': [[45000, 81000]], 'capacity': 100, 'speed': 30}, 
#             {'id': 10741, 'time_slots': [[20000, 80000]], 'capacity': 100, 'speed': 30}]

# locations = {('1.463877000000025', '103.80627900000007'): {
#     (32280, 35880): [{'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'ref': '31849', 
#                         'order_time': 0, 
#                         'delivery_window': [32280, 35880], 
#                         'capacity': 0, 
#                         'coordinates': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'address': '58 Senoko Drive Singapore'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'pickup_address': '58 Senoko Drive Singapore', 
#                         'pickup_window': [32280, 35880], 
#                         'ref': '31849', 'order_time': 0, 
#                         'delivery_window': [31680, 60480], 
#                         'capacity': 1, 
#                         'coordinates': [Decimal('1.2849899230000688'), Decimal('103.83309993300009')], 
#                         'address': 'TIONG BAHRU MARKET'}], 
#     (32400, 36000): [{'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'ref': '31850', 
#                         'order_time': 0, 
#                         'delivery_window': [32400, 36000], 
#                         'capacity': 0, 
#                         'coordinates': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'address': '58 Senoko Drive Singapore'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'pickup_address': '58 Senoko Drive Singapore', 
#                         'pickup_window': [32400, 36000], 
#                         'ref': '31850', 
#                         'order_time': 0, 
#                         'delivery_window': [36000, 64800], 
#                         'capacity': 1, 
#                         'coordinates': [Decimal('1.3679500000000644'), Decimal('103.83866000000006')], 
#                         'address': 'ANG MO KIO AVE 4 BLK 628'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                         'pickup_address': '58 Senoko Drive Singapore', 
#                         'pickup_window': [32400, 36000], 
#                         'ref': '31851', 
#                         'order_time': 0, 
#                         'delivery_window': [36000, 64800], 
#                         'capacity': 1, 
#                         'coordinates': [Decimal('1.3679500000000644'), Decimal('103.83866000000006')], 
#                         'address': 'ANG MO KIO ST'},
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                         'pickup_address': '58 Senoko Drive Singapore',
#                         'pickup_window': [32400, 36000],
#                         'ref': '31852',
#                         'order_time': 0,
#                         'delivery_window': [36000, 64800],
#                         'capacity': 1,
#                         'coordinates': [Decimal('1.286920000000066'), Decimal('103.80747000000008')],
#                         'address': 'JALAN BUKIT MERAH'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')], 
#                         'pickup_address': '58 Senoko Drive Singapore', 
#                         'pickup_window': [32400, 36000], 
#                         'ref': '31853', 
#                         'order_time': 0, 
#                         'delivery_window': [36000, 64800], 
#                         'capacity': 1, 
#                         'coordinates': [Decimal('1.2828600000000279'), Decimal('103.82203000000004')], 
#                         'address': 'BUKIT MERAH VIEW 01-63 BLK115'},
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                         'pickup_address': '58 Senoko Drive Singapore',
#                         'pickup_window': [32400, 36000],
#                         'ref': '31854',
#                         'order_time': 0,
#                         'delivery_window': [36000, 64800],
#                         'capacity': 1,
#                         'coordinates': [Decimal('1.3679500000000644'), Decimal('103.83866000000006')],
#                         'address': 'BLK 232 ANG MO KIO AVE 3'},
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31855',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.2849899230000688'), Decimal('103.83309993300009')],
#                          'address': 'TIONG BAHRU MARKET'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31856',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.2849600000000692'), Decimal('103.84602000000007')],
#                          'address': 'BLK 531 A UPPER CROSS STREET'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31857',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.371810000000039'), Decimal('103.84474000000006')],
#                          'address': 'ANG MO KIO ST.31 BLK-341 #01-82'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31858', 'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.286920000000066'), Decimal('103.80747000000008')],
#                          'address': 'JALAN BUKIT MERAH BLK 148'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31859',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.2873400000000288'), Decimal('103.81883992900003')],
#                          'address': 'RED HILL BLK 79'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31860',
#                          'order_time': 0,
#                          'delivery_window': [34200, 63000],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.3725600260000306'), Decimal('103.82868006600006')],
#                          'address': 'SEMBAWANG HILL FOOD CENTER'}, 
#                         {'pickup_location': [Decimal('1.463877000000025'), Decimal('103.80627900000007')],
#                          'pickup_address': '58 Senoko Drive Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31861',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.3033400000000483'), Decimal('103.85340000000008')],
#                          'address': 'SIM LIM SQUARE #BI-25'}]}, 
# ('1.2882240000000706', '103.84713900000008'): {
#     (32400, 36000): [{'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')], 
#                         'ref': '31862', 
#                         'order_time': 0, 
#                         'delivery_window': [32400, 36000], 
#                         'capacity': 0, 
#                         'coordinates': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')], 
#                         'address': '45 New Bridge Road Singapore'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31862', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.3679500000000644'), Decimal('103.83866000000006')], 'address': 'BLK 162 ANG MO KIO AVE 4'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31863', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.3066727810000316'), Decimal('103.85079553500009')], 'address': 'Buffalo Road, Singapore'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31864', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.2828600000000279'), Decimal('103.82203000000004')], 'address': 'BLK 115 BUKIT MERAH VIEW #01-59'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31865', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.2849899230000688'), Decimal('103.83309993300009')], 'address': 'TIONG BAHRU MARKET'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31866', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.303490044000057'), Decimal('103.76398007100005')], 'address': 'BLK 320 SHUN FU RD'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31867', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.2931500550000692'), Decimal('103.85283000500004')], 'address': 'BLK 116 JALAN TENTERAM'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000],
#                          'ref': '31868', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1,
#                          'coordinates': [Decimal('1.2880999480000241'), Decimal('103.81817004800007')], 'address': 'BLK 85 REDHIL MARKET'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')], 'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000], 'ref': '31869', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1, 'coordinates': [Decimal('1.282309984000051'), Decimal('103.85996992800006')], 'address': '101 UPPER CROSS ST 摊位 6 号'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')], 'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000], 'ref': '31870', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1, 'coordinates': [Decimal('1.2990780000000655'), Decimal('103.83874650000007')], 'address': 'Comcentre, Singapore'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')], 'pickup_address': '45 New Bridge Road Singapore', 'pickup_window': [32400, 36000], 'ref': '31871', 'order_time': 0, 'delivery_window': [36000, 64800], 'capacity': 1, 'coordinates': [Decimal('1.3622100160000628'), Decimal('103.85508000800007')], 'address': '1 KADAYANALLUR STREET'}, 
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31872',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.2799000340000362'), Decimal('103.84721994900008')],
#                          'address': 'MOSQUE ST NO. 41'},
#                         {'pickup_location': [Decimal('1.2882240000000706'), Decimal('103.84713900000008')],
#                          'pickup_address': '45 New Bridge Road Singapore',
#                          'pickup_window': [32400, 36000],
#                          'ref': '31873',
#                          'order_time': 0,
#                          'delivery_window': [36000, 64800],
#                          'capacity': 1,
#                          'coordinates': [Decimal('1.2852644430000737'), Decimal('103.83167645500004')],
#                          'address': 'Lim Liak Street, Singapore'}]}}


drivers_merge = [{'id': 1, 'time_slots': [[32400, 64800]], 'capacity': 15, 'speed': 30},            
           {'id': 2, 'time_slots': [[32400, 83800]], 'capacity': 15, 'speed': 30}, 
           {'id': 3, 'time_slots': [[32400, 83800]], 'capacity': 15, 'speed': 30}, 
           {'id': 4, 'time_slots': [[32400, 83800]], 'capacity': 15, 'speed': 30}, 
           {'id': 5, 'time_slots': [[32400, 83800]], 'capacity': 15, 'speed': 30},
           {'id': 6, 'time_slots': [[32400, 83800]], 'capacity': 20, 'speed': 30},
           {'id': 7, 'time_slots': [[32400, 83800]], 'capacity': 20, 'speed': 30}]

locations_merge = {'Fishermall, Diliman, Quezon City': {
    (32400, 36000): [{'address': 'Fishermall, Diliman, Quezon City',
                      'coordinates': [14.6336204, 121.0193792],
                      'delivery_window': [32400, 36000],
                      'capacity': 0,
                      'order_time': 0}, 
                     {'address': 
                      'Pacific Rim Cor. Commerce Ave., Filinvest City, Alabang, Muntinlupa City, 1781 Metro Manila, Philippines',
                      'coordinates': [14.4200106, 121.033259],
                      'delivery_window': [39600, 46800],
                      'capacity': 1,
                      'order_time': 0,
                      'ref': '1000005264'}, 
                     {'address': '4 Kamias Rd, Diliman, Quezon City, Metro Manila',
                      'coordinates': [14.6310151, 121.0467182],
                      'delivery_window': [39600, 46800],
                      'capacity': 1,
                      'order_time': 0,
                      'ref': '1000005265'}, 
                     {'address': '30 Humility St Multinational Village, Paranaque',
                      'coordinates': [14.4804117, 121.0048727],
                      'delivery_window': [39600, 46800],
                      'capacity': 1,
                      'order_time': 0,
                      'ref': '1000005268'}, 
                     {'address': 'Blk 6 lot 13 kalayaan village, brgy. 201, Pasay',
                      'coordinates': [14.507602, 121.029081],
                      'delivery_window': [39600, 46800],
                      'capacity': 2,
                      'order_time': 0,
                      'ref': '1000005274'}, 
                     {'address': 'Barangay 34, Maypajo, Caloocan, Metro Manila, Philippines', 'coordinates': [14.6367721, 120.9729332], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005183'}, 
                     {'address': '2611 Taft Ave, Barangay 68, Pasay City', 'coordinates': [14.5783882, 120.986897], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005184'}, 
                     {'address': '1838 Yakal St, Manila, 237', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 4, 'order_time': 0, 'ref': '1000005186'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 4, 'order_time': 0, 'ref': '1000005188'},
                     {'address': '18 Molave St., Marietta-Romeo Village, Brgy Sta Lucia, Pasig', 'coordinates': [14.5815801, 121.1017699], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005189'}, 
                     {'address': '86E Cotabato St.\nBago Bantay\nAlicia, Quezon City',
                      'coordinates': [14.6619823, 121.0235792],
                      'delivery_window': [39600, 46800],
                      'capacity': 1,
                      'order_time': 0,
                      'ref': '1000005190'}, 
                     {'address': 'BLK 10 Lot 7 Cor Chesa St Model Community, Bgy 120, Zone 009 Tondo, Manila, Philippines',
                      'coordinates': [14.6205654, 120.9659653],
                      'delivery_window': [39600, 46800],
                      'capacity': 1,
                      'order_time': 0,
                      'ref': '1000005192'}, 
                     {'address': 'Le Gran Condominium Eisenhower St. Greenhills, San Juan', 'coordinates': [14.607297, 121.048476], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005205'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 3, 'order_time': 0, 'ref': '1000005211'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 4, 'order_time': 0, 'ref': '1000005224'}, 
                     {'address': '1320 CP Garcia St Moriones, Bgy 123, Zone 009 Tondo, Manila', 'coordinates': [14.6096907, 120.9618301], 'delivery_window': [39600, 46800], 'capacity':2, 'order_time': 0, 'ref': '1000005225'}, 
                     {'address': 'Fairways Towers 5th Avenue corner McKinley Road, Taguig\nUnit N 15A/15/Fairways Towers', 'coordinates': [14.545619, 121.0454128], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005229'}, 
                     {'address': '1310 C. P. Garcia Street, Tondo, Manila, Metro Manila, Philippines', 'coordinates': [14.6105919, 120.9617521], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005233'}, 
                     {'address': '1320 CP Garcia St Moriones, Bgy 123, Zone 009 Tondo, Manila', 'coordinates': [14.6096907, 120.9618301], 'delivery_window': [39600, 46800], 'capacity': 2, 'order_time': 0, 'ref': '1000005236'}, 
                     {'address': '2176 Jesus St pandacan manila', 'coordinates': [14.5926865, 121.0044297], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005243'}, 
                     {'address': '156 Session Road Quezon City Batasan Hills', 'coordinates': [14.6797936, 121.1032391], 'delivery_window': [39600, 46800], 'capacity': 1, 'order_time': 0, 'ref': '1000005250'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [39600, 46800], 'capacity': 5, 'order_time': 0, 'ref': '1000005254'}], 
    (32000, 38600): [{'address': 'Fishermall, Diliman, Quezon City', 'coordinates': [14.6336204, 121.0193792],'delivery_window': [39600, 43200], 'capacity': 0, 'order_time': 0}, 
                     {'address': 'Anaheim 2, California Garden Square, D.M. Guevara St., Highway Hills, Mandaluyong', 'coordinates': [14.5786156, 121.047485], 'delivery_window': [46800, 52600], 'capacity': 2, 'order_time': 0, 'ref': '1000005266'}, 
                     {'address': 'Lebanon Street Don Bosco, Paranaque', 'coordinates': [14.4786895, 121.0327488], 'delivery_window': [46800, 52600], 'capacity': 1, 'order_time': 0, 'ref': '1000005228'}], 
    (62400, 64000): [{'address': 'Fishermall, Diliman, Quezon City', 'coordinates': [14.6336204, 121.0193792], 'delivery_window': [64000, 72000], 'capacity': 0, 'order_time': 0}, 
                     {'address': '940, Maligaya Street, Manila', 'coordinates': [14.5665457, 120.9952634], 'delivery_window': [64800, 72000], 'capacity': 1, 'order_time': 0, 'ref': '1000005242'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [64800, 72000], 'capacity': 5, 'order_time': 0, 'ref': '1000005255'}, 
                     {'address': '1838 Yakal St 237, Manila', 'coordinates': [14.6156181, 120.9790745], 'delivery_window': [75600, 82800], 'capacity': 5, 'order_time': 0, 'ref': '1000005257'}], 
    (50400, 54000): [{'address': 'Fishermall, Diliman, Quezon City',
                      'coordinates': [14.6336204, 121.0193792],
                      'delivery_window': [50400, 54000],
                      'capacity': 0,
                      'order_time': 0}, 
                     {'address': '81F Madasalin St Teachers Village East Diliman, Quezon City',
                      'coordinates': [14.6410582, 121.0591618],
                      'delivery_window': [57600, 64800],
                      'capacity': 2,
                      'order_time': 0,
                      'ref': '1000025061'}]}}